#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mpsapi.h"
#include "plugin-common.h"
//
//	    
//	     runtime
//
OpcMP_status_t  PLUGIN_INIT(OpcMP_plugin_t * plugin)
{
	// get plugin specific data 
	const char *tmp;
	char errbuf[256];
	//   
	mps_DebugMessage(plugin, "plugin :init");

	//   
	mps_mutex_lock(plugin);
	// init plugin data

	//     
	my_plugin_data * data = (my_plugin_data *)mps_malloc(plugin, sizeof(my_plugin_data));
	// get plugin config 

	//     
	int countdevice_properties = mps_getNumberDeviceProperties(plugin);

	//    
	mps_Object	*propdevicenode = mps_getDeviceProperties(plugin);

	//         
	mps_setPluginData(plugin, (void *)data);
	char rb[80];

	//         
	data->typedevice = mps_property_as_int(propdevicenode, "type", 0);
	data->address = mps_property_as_int(propdevicenode, "address", 0);
	data->ksum = mps_property_as_bool(propdevicenode, "csum", false);
	data->FirstRun = true;

	//      (  )
	int counttags_properties = mps_getNumberTagsProperties(plugin);
	//
	for (int i = 0; i < counttags_properties; i++){
		mps_Object  *propnode;
		OpcMP_tag_t *opcmp_tag;
		my_tagdata  *mytagdata;
		// variable to the min value 

		// C   
		opcmp_tag = (OpcMP_tag_t *)mps_getPluginTag(plugin, i);

		//    
		propnode = mps_getTagProperties(plugin, i);

		//     
		mytagdata = (my_tagdata*)mps_malloc(plugin, sizeof(my_tagdata));

		//         
		mytagdata->TypeChannel = mps_property_as_string(propnode, "type", "");
		mytagdata->NumberChannel = mps_property_as_int(propnode, "channel1", 1000);

		//     
		mps_setTagData(opcmp_tag, mytagdata);
	}
	//  
	mps_mutex_unlock(plugin);

	return OPCMP_SUCCESS;
}
