#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mpsapi.h"
#include "usclasses.h"
#include "usstr.h"
#include "plugin-common.h"  
//
//
//	  
//	      
//
OpcMP_status_t closesubdevice(OpcMP_plugin_t * plugin){
	OpcMP_status_t status = OPCMP_SUCCESS;
	mps_DebugMessage(plugin, "plugin :subdevice close");
	//   
	my_subdevice_data * data = (my_subdevice_data*)mps_getPluginData(plugin);
	//   
	if (data->ID != NULL)
		mps_free(plugin,data->ID);
	data->tags->clear();
	delete data->tags;
	mps_free(plugin,data);
	//     
	int NumberTags = mps_getPluginNumberTags(plugin);
	//    
	for (int i = 0; i < NumberTags; i++)
	{
		//     
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)mps_getPluginTag(plugin, i);
		//   
		my_tagdata * tagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		if (tagdata != NULL)
		{
			if (tagdata->TypeChannel != NULL)
				mps_free(plugin, (void *)tagdata->TypeChannel);
			mps_free(plugin, (void *)tagdata);
		}
	}
	mps_DebugMessage(plugin, "plugin :subdevice close end");
	return status;
}
OpcMP_status_t PLUGIN_CLOSE(OpcMP_plugin_t * plugin)
{
	OpcMP_status_t status = OPCMP_SUCCESS;
	//   
	my_device_data * data = (my_device_data*)mps_getPluginData(plugin);
	//    
	if (data != NULL){
		if (data->ID != NULL){
			mps_free(plugin, (OpcMP_Void *)data->ID);
		}
		delete data->tags;
		mps_free(plugin, data);
	}
	//     
	int NumberTags = mps_getPluginNumberTags(plugin);
	//     
	for (int i = 0; i < NumberTags; i++)
	{
		//     
		OpcMP_tag_t *tag = (OpcMP_tag_t *)mps_getPluginTag(plugin, i);
		//   
		my_tagdata * data = (my_tagdata *)mps_getTagData(tag);
		if (data != NULL){
			if (data->TypeChannel != NULL){
				mps_free(plugin, (OpcMP_Void *)data->TypeChannel);
			}
			mps_free(plugin, (OpcMP_Void *)data);
		}
	}
	//   
	int subdevicesnumber = mps_getPluginSubDevicesNumber(plugin);
	//  
	for (int i = 0; i < subdevicesnumber; i++){
		// 
		OpcMP_plugin_t *subdevice = mps_getPluginSubDeviceByNumber(plugin, i);
		status = closesubdevice(subdevice);
	}
	return OPCMP_SUCCESS;
}
