#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "mps_Object.h"
#include "usclasses.h"
//#include "usfunc.h"
#include "mpsapi.h"
//#include "usvariant.h"
#include "plugin-common.h"
void getCRCDCON(unsigned char *RecvBuffer, int Len, char *chksumStr)
{
	unsigned short chksum = 0;
	int pos;
	for (pos = 0; pos < Len; pos++)
		chksum = (chksum + RecvBuffer[pos]) % 0x100;
	sprintf(chksumStr, "%02X", chksum);
}
OpcMP_Int32 SendBlockToRs(OpcMP_plugin_t *Plugin, int port, char *SourceBuffer, int SourceLen, char *DestBuffer, int DestLen, int TimeOut1,boolean csum)
{
	int result;
	char WorkBuf[2048];
	char WorkBufRecv[2048];
	mps_sendandreceive_t sendandreceive;
	if (Plugin == NULL)
		return -1;
	sendandreceive = mps_getSendAndReceive(Plugin);
	if (sendandreceive == NULL)
		return -1;
	if (csum == true)
	{
		memset(WorkBuf, 0, sizeof(WorkBuf));
		memcpy(WorkBuf, SourceBuffer, SourceLen);
		getCRCDCON((unsigned char *)SourceBuffer, SourceLen - 1, &WorkBuf[SourceLen - 1]);
		WorkBuf[SourceLen + 1] = '\r';
		result = sendandreceive(Plugin, (unsigned char *)&WorkBuf[0], SourceLen + 2, (unsigned char *)&WorkBufRecv[0], DestLen + 2);
		if (result > 3)
		{
			char ksum[3];
			getCRCDCON((unsigned char *)&WorkBufRecv[0], DestLen - 1, &ksum[0]);
			if ((ksum[0] == WorkBufRecv[DestLen - 1]) && (ksum[1] == WorkBufRecv[DestLen]))
			{
				memcpy(DestBuffer, WorkBufRecv, DestLen);
				DestBuffer[DestLen - 1] = '\r';
				return result;
			}
			else
				result - 1;
		}
		else
		{
			result = -1;
		}
	}
	else
	{
		result = sendandreceive(Plugin, (unsigned char *)SourceBuffer, SourceLen, (unsigned char *)DestBuffer, DestLen);
	}
	return result;
};
bool WriteTagToHDA(OpcMP_plugin_t *Plugin, OpcMP_tag_t *Tag)
{
	int result;
	char WorkBuf[2048];
	char WorkBufRecv[2048];
	mps_writetohda_t writetohda;
	if (Plugin == NULL)
		return -1;
	writetohda = mps_getWriteToHda(Plugin);
	if (writetohda == NULL)
		return false;
	return writetohda(Plugin, Tag);
};
OpcMP_Boolean  ReadDevice(OpcMP_plugin_t * plugin, USList *readvar)
{
	OpcMP_Boolean result = OpcMP_True;
	for (int i = 0; i < readvar->count(); i++)
	{
		OpcMP_tag_t *tag = (OpcMP_tag_t *)readvar->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(tag);
		if (mytagdata == NULL)
			continue;
		mps_setTagQwality(tag,192);
	};
	return result;
}
OpcMP_Boolean ReadSubDevice(OpcMP_plugin_t * plugin, USList *readvar)
{
	OpcMP_tag_t *opcmp_tag_error = NULL;
	OpcMP_Boolean result = OpcMP_True;
	OpcMP_plugin_t *deviceplugin = mps_getPluginDevicePlugin(plugin);
	my_device_data * devicedata = (my_device_data*)mps_getPluginData(deviceplugin);
	my_subdevice_data * subdevicedata = (my_subdevice_data*)mps_getPluginData(plugin);
	struct Zapros *Zpr = new struct Zapros;
	Zpr->Typ = devicedata->typedevice;
	Zpr->QKind = 0;
	Zpr->Address	= subdevicedata->address;
	Zpr->ksum		= subdevicedata->csum;
	// analog channel
	bool Error = true;
	USList *readai = new USList;
	USList *readdi = new USList;
	USList *readao = new USList;
	USList *readdo = new USList;
	USList *readci = new USList;
	for (int i = 0; i < readvar->count(); i++)
	{
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)readvar->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		if (mytagdata == NULL)
			continue;
		if (mytagdata->TypeChannel == NULL)
			continue;
		if (strcmp(mytagdata->TypeChannel, "Poll") == 0){
			mps_setTagQwality(opcmp_tag, 192);
			continue;
		}
		else if (strcmp(mytagdata->TypeChannel, "Failure") == 0){
			mps_setTagQwality(opcmp_tag, 192);
			continue;
		}
		else if (strcmp(mytagdata->TypeChannel, "AI") == 0){
			readai->add(opcmp_tag);
		}
		else if (strcmp(mytagdata->TypeChannel, "AO") == 0){
			readao->add(opcmp_tag);
		}
		else if (strcmp(mytagdata->TypeChannel, "DI") == 0){
			readdi->add(opcmp_tag);
		}
		else if (strcmp(mytagdata->TypeChannel, "DO") == 0){
			readdo->add(opcmp_tag);
		}
		else if (strcmp(mytagdata->TypeChannel, "CI") == 0){
			readci->add(opcmp_tag);
		}
		else;
	}
	for (int i = 0; i < readai->count(); i++)
	{
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)readai->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		Zpr->Channel = mytagdata->NumberChannel;
		Zpr->Status = 0;//Analog
		if (i == 0)
			Zpr->QKind = 2;
		else
			Zpr->QKind = 1;
		Read(deviceplugin, Zpr);
		if (Zpr->Status == -1)
		{
			mps_setTagQwality(opcmp_tag, OPCMP_QUALITY_BAD);
			Error = true;
		}
		else
		{
			float Val = *(float *)Zpr->Buffer;
			mps_setTagAsFloat(opcmp_tag, Val);
			Error = false;
		}
		mps_setTagAsFloat(subdevicedata->tagFailure, Error);
		mps_setTagAsFloat(subdevicedata->tagDeviceFailure, Error);
	}
	bool NeedReadDi = true;
	for (int i = 0; i < readdi->count(); i++)
	{
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)readdi->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		Zpr->Channel = mytagdata->NumberChannel;
		Zpr->Status = 1;//Discrete
		if (i == 0)
			Zpr->QKind = 2;
		else
			Zpr->QKind = 1;
		if (NeedReadDi)
			Read(deviceplugin, Zpr);
		else
			Zpr->Status = -1;
		if (Zpr->Status == -1)
		{
			if (Zpr->QKind == 2)
				NeedReadDi = false;
			mps_setTagAsFloat(opcmp_tag, 0, OPCMP_QUALITY_BAD);
			Error = true;
		}
		else
		{
			unsigned int Val = *(unsigned short int *)Zpr->Buffer;
			mps_setTagAsFloat(opcmp_tag, Val);
			Error = false;
		}
		mps_setTagAsFloat(subdevicedata->tagFailure, Error);
		mps_setTagAsFloat(subdevicedata->tagDeviceFailure, Error);
	}
	for (int i = 0; i < readdo->count(); i++)
	{
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)readdo->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		Zpr->Channel = mytagdata->NumberChannel;
		Zpr->Status = 1;//Discrete
		if (subdevicedata->FirstRun == true)
			Zpr->QKind = 2;
		else
			Zpr->QKind = 1;
		ReadWrite(deviceplugin, Zpr);
		if (Zpr->Status == -1)
		{
			mps_setTagAsFloat(opcmp_tag, NOTUSEVALUE, OPCMP_QUALITY_BAD);
			Error = true;
		}
		else
		{
			unsigned int Val = *(unsigned short int *)Zpr->Buffer;
			mps_setTagAsFloat(opcmp_tag, Val);
			Error = false;
		}
		mps_setTagAsFloat(subdevicedata->tagFailure, Error);
		mps_setTagAsFloat(subdevicedata->tagDeviceFailure, Error);
	}
	for (int i = 0; i < readci->count(); i++)
	{
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)readci->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		Zpr->Channel = mytagdata->NumberChannel;
		Zpr->Status = 2;//CI
		if (i == 0)
			Zpr->QKind = 2;
		else
			Zpr->QKind = 1;
		ReadCI(deviceplugin, Zpr);
		if (Zpr->Status == -1)
		{
			mps_setTagAsFloat(opcmp_tag, NOTUSEVALUE, OPCMP_QUALITY_BAD);
			Error = true;
		}
		else
		{
			unsigned int Val = *(unsigned short int *)Zpr->Buffer;
			mps_setTagAsFloat(opcmp_tag, Val);
			Error = false;
		}
		mps_setTagAsFloat(subdevicedata->tagFailure, Error);
		mps_setTagAsFloat(subdevicedata->tagDeviceFailure, Error);
	}
	delete readai;
	delete readdi;
	delete readao;
	delete readdo;
	delete readci;
	delete Zpr;
	return result;
}
//
OpcMP_tag_t * getErrorTag(OpcMP_plugin_t * plugin)
{
	int NumberTags = mps_getPluginNumberTags(plugin);
	for (int i = 0; i < NumberTags; i++)
	{
		OpcMP_tag_t *tag = mps_getPluginTag(plugin, i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(tag);
		if (strcmp(mytagdata->TypeChannel, "Error") == 0)
			return tag;
	}
	return NULL;
}
OpcMP_Boolean WriteDevice(OpcMP_plugin_t * plugin, USList *writevar)
{
	OpcMP_tag_t *opcmp_tag_error = NULL;
	OpcMP_Boolean result = OpcMP_True;
	// plugin 
	OpcMP_plugin_t *deviceplugin = plugin;
	//  
	my_device_data * data = (my_device_data*)mps_getPluginData(deviceplugin);
	for (int i = 0; i < writevar->count(); i++)
	{
		OpcMP_tag_t *tag = (OpcMP_tag_t *)writevar->getItem(i);
		my_tagdata * data = (my_tagdata *)mps_getTagData(tag);
		if (strcmp(data->TypeChannel, "Poll") == 0){
			//  Poll
			mps_setTagAsBoolean(tag, OpcMP_False);
			//   
			mps_setTagHBW(tag); // Has Been Writed
			//    
			mps_setDataReady(plugin, 0);
		}
	}
	return result;
}

OpcMP_Boolean  WriteSubDevice(OpcMP_plugin_t * plugin, USList *writevar)
{
	OpcMP_tag_t *tag_error = NULL;
	OpcMP_Boolean  result = OpcMP_True;
	// plugin 
	OpcMP_plugin_t *deviceplugin = mps_getPluginDevicePlugin(plugin);
	//  
	my_device_data * devicedata = (my_device_data*)mps_getPluginData(deviceplugin);
	//  
	my_subdevice_data *subdevicedata = (my_subdevice_data*)mps_getPluginData(plugin);
	//  
	struct Zapros *Zpr = new struct Zapros;
	Zpr->Typ = devicedata->typedevice;
	Zpr->QKind = 0;
	Zpr->Address = subdevicedata->address;
	Zpr->ksum = subdevicedata->csum;
	// analog channel
	OpcMP_Boolean Error = OpcMP_True;
	USList *writeao = new USList;
	USList *writedo = new USList;
	tag_error = subdevicedata->tagFailure;
	for (OpcMP_Int32 i = 0; i < writevar->count(); i++)
	{
		OpcMP_tag_t *tag = (OpcMP_tag_t *)writevar->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(tag);
		if (strcmp(mytagdata->TypeChannel, "Poll") == 0){
			//  Poll
			mps_setTagAsBoolean(tag,OpcMP_False);
			//   
			mps_setTagHBW(tag); // Has Been Writed
			//    
			mps_setDataReady(plugin,0);
		}
		else if (strcmp(mytagdata->TypeChannel, "AO") == 0){
			writeao->add(tag);
		}
		else if (strcmp(mytagdata->TypeChannel, "DO") == 0){
			writedo->add(tag);
		}
	}
	for (OpcMP_Int32 i = 0; i < writeao->count(); i++)
	{
		OpcMP_tag_t *tag = (OpcMP_tag_t *)writeao->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(tag);
		Zpr->Channel = mytagdata->NumberChannel;
		Zpr->Status = 0;//Analog
		if (i == writeao->count() - 1)
			Zpr->QKind = 2;
		else
			Zpr->QKind = 1;
		Write(deviceplugin, Zpr);
		if (Zpr->Status == -1)
		{
			Error = true;
			mps_setTagQwality(tag, OPCMP_QUALITY_BAD); // No Writed
		}
		else
		{
			mps_setTagHBW(tag); // Has Been Writed
			Error = false;
		}
	}
	for (OpcMP_Int32 i = 0; i < writedo->count(); i++)
	{
		OpcMP_Boolean Val;
		mps_TagData tagdata;
		OpcMP_tag_t *tag = (OpcMP_tag_t *)writedo->getItem(i);
		my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(tag);
		Zpr->Channel = mytagdata->NumberChannel;
		Zpr->Status = 1;//Discrete
		Val = mps_getTagAsBoolean(tag);
		if (i == writedo->count() - 1)
			Zpr->QKind = 2;
		else
			Zpr->QKind = 1;
		*(unsigned short int *)&Zpr->Buffer[0] = Val;
		Write(deviceplugin, Zpr);
		if (Zpr->Status == -1)
		{
			Error = OpcMP_True;
			mps_setTagQwality(tag, OPCMP_QUALITY_BAD); // No Writed
		}
		else
		{
			mps_setTagHBW(tag); // Has Been Writed
			Error = OpcMP_False;
		}
		mps_setTagAsFloat(tag_error, Error);		// tag Error
	}
	writeao->clear();
	delete writeao;
	writedo->clear();
	delete writedo;
	delete Zpr;
	return result;
}
