#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <vector>
#include <string>
#include "mpsapi.h"
#include "plugin-common.h"
//
//	    
//	     runtime
//
OpcMP_status_t  PLUGIN_INIT(OpcMP_plugin_t * plugin)
{
	// get plugin specific data 
	const char *tmp;
	char errbuf[256];
	//   
	mps_DebugMessage(plugin, "plugin :init");
	//   
	mps_mutex_lock(plugin);
	// init plugin data
	//     
	my_device_data * devicedata = (my_device_data *)mps_malloc(plugin, sizeof(my_device_data));
	//    
	mps_Object	*propdevicenode = mps_getDeviceProperties(plugin);
	//         
	devicedata->typedevice	= mps_property_as_int(propdevicenode, "type", 0);
	devicedata->ID = mps_getPluginID(plugin);
	//   
	OpcMP_tag_t *tagFailure = mps_getPluginTagByID(plugin, "Failure");;
	devicedata->tagFailure = tagFailure;
	//    
	OpcMP_tag_t *tagPoll = mps_getPluginTagByID(plugin, "Poll");;
	devicedata->tagPoll = tagPoll;
	//         
	mps_setPluginData(plugin, (void *)devicedata);
	//    
	int tagsnumber = mps_getPluginTagsNumber(plugin);
	// c   
	devicedata->tags = new USList;
	//  
	for (int j = 0; j < tagsnumber; j++){
		mps_Object  *propnode;
		OpcMP_tag_t *tag;
		my_tagdata  *data;
		// C   
		tag = (OpcMP_tag_t *)mps_getPluginTag(plugin, j);
		//    
		propnode = mps_getTagProperties(plugin, j);
		//     
		data = (my_tagdata*)mps_malloc(plugin, sizeof(my_tagdata));
		//         
		data->TypeChannel = mps_property_as_string(propnode, "type", "");
		data->NumberChannel = mps_property_as_int(propnode, "channelnumber", 1000);
		//     
		mps_setTagData(tag, data);
		//    
		devicedata->tags->add(tag);
	}
	//   
	int subdevicesnumber = mps_getPluginSubDevicesNumber(plugin);
	//  
	for (int i = 0; i < subdevicesnumber; i++){
		my_subdevice_data *mysubdevicedata;
		//     
		mysubdevicedata = (my_subdevice_data*)mps_malloc(plugin, sizeof(my_subdevice_data));
		// 
		OpcMP_plugin_t *subdevice = mps_getPluginSubDeviceByNumber(plugin,i);
		// ID 
		mysubdevicedata->ID = mps_getPluginID(subdevice);
		//   
		mysubdevicedata->tagDeviceFailure = tagFailure;
		//   
		mysubdevicedata->tagFailure = mps_getPluginTagByID(subdevice,"Failure");
		//   
		mysubdevicedata->tagPoll = mps_getPluginTagByID(subdevice, "Poll");
		// 
		mps_Object	*propsubdevicenode = mps_getPluginProperties(subdevice);
		mysubdevicedata->address = mps_property_as_uint(propsubdevicenode, "address",1);
		mysubdevicedata->csum = mps_property_as_bool(propsubdevicenode, "csum",false);
		//     
		mps_setPluginData(subdevice, mysubdevicedata);
		//   
		int tagsnumber = mps_getPluginTagsNumber(subdevice);
		// c   
		mysubdevicedata->tags = new USList;
		//  
		for (int j = 0; j < tagsnumber; j++){
			mps_Object  *propnode;
			OpcMP_tag_t *tag;
			my_tagdata  *mytagdata;
			// C   
			tag = (OpcMP_tag_t *)mps_getPluginTag(subdevice, j);
			//    
			propnode = mps_getTagProperties(subdevice, j);
			//     
			mytagdata = (my_tagdata*)mps_malloc(plugin, sizeof(my_tagdata));
			//         
			mytagdata->TypeChannel = mps_property_as_string(propnode, "type", "");
			mytagdata->NumberChannel = mps_property_as_int(propnode, "channelnumber", 1000);
			//     
			mps_setTagData(tag, mytagdata);
			//    
			mysubdevicedata->tags->add(tag);
		}
	}
	//  
	mps_mutex_unlock(plugin);

	return OPCMP_SUCCESS;
}
