#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "config.h"
#include "mpsapi.h"
#include "usclasses.h"
#include "usstr.h"
#include "plugin-common.h" 
//
//	   
//      
//
OpcMP_status_t readdevice(OpcMP_plugin_t * plugin){
	OpcMP_status_t status = OPCMP_SUCCESS;
	USList *readvar = new USList;
	mps_DebugMessage(plugin, "plugin: device read");
	//   
	my_device_data * data = (my_device_data*)mps_getPluginData(plugin);
	//    
	OpcMP_Int32 tagsnumber = mps_getPluginNumberReadTags(plugin);
	//  
	for (OpcMP_Int32 i = 0; i < tagsnumber; i++){
		OpcMP_tag_t *tag = mps_getPluginReadTag(plugin,i);
		//   
		my_tagdata * data = (my_tagdata*)mps_getTagData(tag);
		if (data == NULL)
			continue;
		readvar->add(tag);
	}
	//   
	OpcMP_Boolean result = ReadDevice(plugin,readvar);
	delete readvar;
	mps_DebugMessage(plugin, "plugin: device end read");
	return status;
}

OpcMP_status_t readsubdevice(OpcMP_plugin_t * plugin){
	OpcMP_status_t status = OPCMP_SUCCESS;
	USList *readvar = new USList;;
	mps_DebugMessage(plugin, "plugin: subdevice read");
	//   
	my_subdevice_data * data = (my_subdevice_data*)mps_getPluginData(plugin);
	//    
	OpcMP_Int32 tagsnumber = mps_getPluginNumberReadTags(plugin);
	//  
	for (OpcMP_Int32 i = 0; i < tagsnumber; i++){
		OpcMP_tag_t *tag = mps_getPluginReadTag(plugin, i);
		//   
		my_tagdata * data = (my_tagdata*)mps_getTagData(tag);
		if (data == NULL)
			continue;
		readvar->add(tag);
	}
	//   
	OpcMP_Boolean result = ReadSubDevice(plugin,readvar);
	delete readvar;
	mps_DebugMessage(plugin, "plugin: subdevice end read");
	return status;
}

OpcMP_status_t PLUGIN_READ(OpcMP_plugin_t * plugin)
{
	OpcMP_status_t status = OPCMP_SUCCESS;
	if (mps_getPluginNeedScan(plugin) == OpcMP_True){
		readdevice(plugin);
	}
	//  
	OpcMP_UInt32 subdevicesnumber = mps_getPluginSubDevicesNumber(plugin);
	//   
	for (OpcMP_Int32 i = 0; i < subdevicesnumber; i++){
		OpcMP_plugin_t *subdevice = mps_getPluginSubDeviceByNumber(plugin, i);
		if (mps_getPluginNeedScan(subdevice) == OpcMP_True){
			 readsubdevice(subdevice);
		}
	}
	return status;
};
