#ifdef _WIN32
//#include <windows.h>
//#include <Winsock2.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "config.h"
#include "mpsapi.h"
#include "usclasses.h"
#include "usstr.h"
#include "plugin-common.h"
//
//   
//      
//
OpcMP_status_t writedevice(OpcMP_plugin_t * plugin){
	OpcMP_status_t status = OPCMP_SUCCESS;
	//   
	mps_DebugMessage(plugin, "plugin :device write");
	USList *writevar = NULL;
	//   
	my_device_data * data = (my_device_data*)mps_getPluginData(plugin);
	//        
	int NumberTags = mps_getPluginNumberWriteTags(plugin);
	writevar = new USList();
	for (int i = 0; i < NumberTags; i++){
		const char * varname = NULL;
		//    
		OpcMP_tag_t *tag = (OpcMP_tag_t *)mps_getPluginWriteTag(plugin, i);
		//    
		my_tagdata * data = (my_tagdata *)mps_getTagData(tag);
		if (data == NULL){

			continue;
		}
		writevar->add(tag);
	}
	//   
	if (writevar->count()){
		OpcMP_Boolean result = WriteDevice(plugin, writevar);
	}
	//   
	writevar->clear();
	delete writevar;
	mps_DebugMessage(plugin, "plugin :subdevice write end");
	return status;
}

OpcMP_status_t writesubdevice(OpcMP_plugin_t * plugin){
	OpcMP_status_t status = OPCMP_SUCCESS;
	//   
	mps_DebugMessage(plugin, "plugin :subdevice write");
	USList *writevar = NULL;
	//   
	my_subdevice_data * subdevicedata = (my_subdevice_data*)mps_getPluginData(plugin);
	//        
	int NumberTags = mps_getPluginNumberWriteTags(plugin);
	writevar = new USList();
	for (int i = 0; i < NumberTags; i++){
		const char * varname = NULL;
		//    
		OpcMP_tag_t *tag = (OpcMP_tag_t *)mps_getPluginWriteTag(plugin, i);
		//    
		my_tagdata * data = (my_tagdata *)mps_getTagData(tag);
		if (data == NULL){
			continue;
		}
		writevar->add(tag);
	}
	//   
	if (writevar->count()){
		OpcMP_Boolean result = WriteSubDevice(plugin, writevar);
	}
	//   
	writevar->clear();
	delete writevar;
	mps_DebugMessage(plugin, "plugin :subdevice write end");
	return status;
}
OpcMP_status_t PLUGIN_WRITE(OpcMP_plugin_t * plugin)
{
	OpcMP_status_t status = OPCMP_SUCCESS;
	//  
	if (mps_getPluginNeedWrite(plugin) == OpcMP_True){
		writedevice(plugin);
	}
	//  
	OpcMP_UInt32 subdevicesnumber = mps_getPluginSubDevicesNumber(plugin);
	//   
	for (OpcMP_Int32 i = 0; i < subdevicesnumber; i++){
		OpcMP_plugin_t *subdevice = mps_getPluginSubDeviceByNumber(plugin, i);
		if (mps_getPluginNeedWrite(subdevice) == OpcMP_True){
			writesubdevice(subdevice);
		}
	}
	return status;
};
