#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "usclasses.h"
#include "usfunc.h"
#include "mpsapi.h"
#include "plugin-common.h" 
//
// This function is called by the server to halt and delete any data of device
//
OpcMP_status_t PLUGIN_CLOSE(OpcMP_plugin_t * plugin)
{
	mps_mutex_lock(plugin);
	my_devicedata * devicedata = (my_devicedata*)mps_getPluginData(plugin);
	if (devicedata != NULL){
		if (devicedata->NameDevice != NULL){ mps_free(plugin, devicedata->NameDevice); }
	};
	mps_free(plugin, (void *)devicedata);
	int NumberTags = mps_getPluginNumberTags(plugin);
	for (int i = 0; i < NumberTags; i++){
		;
		OpcMP_tag_t *tag = (OpcMP_tag_t *)mps_getPluginTag(plugin, i);
		my_tagdata * tagdata = (my_tagdata *)mps_getTagData(tag);
		if (tagdata != NULL){
			if (tagdata->SimType != NULL){ mps_free(plugin, tagdata->SimType); }
		};
	};
	mps_DebugMessage(plugin, "plugin: close");
	mps_mutex_unlock(plugin);
	return OPCMP_SUCCESS;
}
