#include <stdio.h>
#include <stdlib.h>
#include <time.h>
//#include "config.h"
#include "mpsapi.h"
#include "usclasses.h"
#include "usfunc.h"
#include "plugin-common.h"
/* METHOD BODY */
//
// This function is called by the server to create any data of device
//
OpcMP_status_t PLUGIN_INIT(OpcMP_plugin_t * plugin)
{
	// blocking others threads of plugin 
	mps_mutex_lock(plugin);
	mps_DebugMessage(plugin, "plugin :init");
	// Allocates memory for own data
	// get number of device properties
	mps_Object	*propertiesdevicenode = mps_getDeviceProperties(plugin);
	my_devicedata *devicedata = (my_devicedata*)mps_malloc(plugin, sizeof(my_devicedata));
	devicedata->NameDevice = mps_property_as_string(propertiesdevicenode, "NameDevice", "Simulator");
	// set data to devicedata
	mps_setPluginData(plugin, (void *)devicedata);
	// Wolking by tags properties
	OpcMP_UInt32 count_tagsproperties = mps_getNumberTagsProperties(plugin);
	for (OpcMP_Int32 i = 0; i < count_tagsproperties; i++){
		OpcMP_tag_t *tag;
		//get tag by number
		tag = (OpcMP_tag_t *)mps_getPluginTag(plugin, i);
		my_tagdata *tagdata = (my_tagdata*)mps_malloc(plugin, sizeof(my_tagdata));
		mps_Object	*propertiesnode = mps_getTagProperties(plugin, i);
		tagdata->SimType = mps_property_as_string(propertiesnode, "SimType", "Saw");
		tagdata->MINSAW = mps_property_as_int(propertiesnode, "MINSAW", 0);
		tagdata->MAXSAW = mps_property_as_int(propertiesnode, "MAXSAW", 10);
		tagdata->DELTASAW = mps_property_as_float(propertiesnode, "DELTASAW", 1);
		tagdata->MINANA = mps_property_as_int(propertiesnode, "MINANA", 0);
		tagdata->MAXANA = mps_property_as_int(propertiesnode, "MAXANA", 10);
		tagdata->DELTASIN = mps_property_as_float(propertiesnode, "DELTASIN", 0.2);
		tagdata->SinArg = 0;
		tagdata->OldValue = 0;
		tagdata->OldString.assign("");
		//	set data to tag
		mps_setTagData(tag, tagdata);
	};
	// unblocking
	mps_mutex_unlock(plugin);
	return OPCMP_SUCCESS;
}
