#ifdef _WIN32
//#include <windows.h>
//#include <Winsock2.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mpsapi.h"
#include "usclasses.h"
#include "usfunc.h"
#include "plugin-common.h"
//
// This function is called by the server to write the tag's value
//
OpcMP_status_t PLUGIN_WRITE(OpcMP_plugin_t * plugin)
{
	int NumberTags;
	char errbuf[1024];
	char rb[80];
	// get plugin specific data 
	USList *writevar = NULL;
	mps_DebugMessage(plugin, "plugin :write");
	writevar = new USList();
	//
	// mps_getPluginNumberWriteTags
	// Returns the driver's number tags for write 
	//
	NumberTags = mps_getPluginNumberWriteTags(plugin);
	for (int i = 0; i < NumberTags; i++)
	{
		const char * varname = NULL;
		//
		// mps_getPluginWriteTag(
		// Returns the driver's tag by number
		//
		OpcMP_tag_t *opcmp_tag = (OpcMP_tag_t *)mps_getPluginWriteTag(plugin, i);
		//
		// mps_getTagData
		// Returns the tag's working structure
		//
		my_tagdata * tagdata = (my_tagdata *)mps_getTagData(opcmp_tag);
		if (tagdata == NULL)
		{
			continue;
		}
		writevar->add(opcmp_tag);
	}
	for (int i = 0; i < writevar->count(); i++)
	{
		//
		// mps_getPluginWriteTag(
		// Returns the driver's tag by number
		//
		OpcMP_tag_t *tag = (OpcMP_tag_t *)mps_getPluginWriteTag(plugin, i);
		//
		// mps_getTagData
		// Returns the tag's working structure
		//
		my_tagdata * tagdata = (my_tagdata *)mps_getTagData(tag);
		if (tagdata == NULL)
			continue;
		if (strcmp(tagdata->SimType, "AnalogConst") == 0)
		{
			// mps_getTagAsFloat
			// Returns the tag's value as float
			//
			float data = mps_getTagAsFloat(tag);
			if (data < tagdata->MINANA )
				data = tagdata->MINANA;
			if (data > tagdata->MAXANA)
				data = tagdata->MAXANA;
			//
			// ps_setTagAsFloat
			// This funcion allows the tag to be set  as float with qwality <<GOOD>>
			//
			mps_setTagAsFloat(tag, data);
			//
			// mps_setTagHBW
			// Put the tag into the state = HAS BEEN WRITED
			//
			mps_setTagHBW(tag);
		}// for vars
		if (strcmp(tagdata->SimType, "StringConst") == 0)
		{
			// mps_getTagAsFloat
			// Returns the tag's value as float
			//
			OpcMP_String  data = mps_getTagAsString(tag);
			//
			// ps_setTagAsFloat
			// This funcion allows the tag to be set  as float with qwality <<GOOD>>
			//
			mps_setTagAsString(tag, data);
			mps_free(plugin, data);
			//
			// mps_setTagHBW
			// Put the tag into the state = HAS BEEN WRITED
			//
			mps_setTagHBW(tag);
		}// for vars

	}
NoVariables:
	if (writevar != NULL)
	{
		writevar->clear();
		delete writevar;
	}
	return OPCMP_SUCCESS;
};
