#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mpsapi.h"
#include "plugin-common.h"

	void SetData(OpcMP_plugin_t *plugin,char *Data,int Len)
	{
		char buf[80];
		int counttags	= mps_getPluginNumberTags(plugin);
		for (int i = 0; i < counttags; i++) {
	      OpcMP_tag_t *tag = (OpcMP_tag_t *)mps_getPluginTag(plugin,i);
		  my_tagdata * mytagdata = (my_tagdata *)mps_getTagData(tag);
		  if (mytagdata == NULL){
			continue;
		  }
		  mps_mutex_lock(plugin);
		  sprintf(buf, " %d ", Len);
		  mps_mutex_unlock(plugin);
		  mytagdata->WasChange = true;
		  mytagdata->Count += Len;
		  mytagdata->String->assign(buf);
		  //   -     (plugin-read)
		  mps_setDataReady(plugin, 0);
		}
	}
	int SendData(OpcMP_plugin_t *plugin,unsigned char *Buffer,int Len)
	{
		int result;
		mps_sendtobuffer_t   sendtobuffer;
		sendtobuffer	    =	(mps_sendtobuffer_t) mps_getPluginMethodSendToBuffer(plugin);
		if (sendtobuffer == NULL)
			return -1;
		result = sendtobuffer(plugin,Buffer,Len);
		return result;
	};
	int RecvData(OpcMP_plugin_t *plugin, unsigned char *Buffer, int Len)
	{
		int result;
		mps_recvfrombuffer_t recvfrombuffer;
		recvfrombuffer = (mps_recvfrombuffer_t)mps_getPluginMethodGetFromBuffer(plugin);
		if (recvfrombuffer == NULL)
			return -1;
		result = recvfrombuffer(plugin, (unsigned char *)Buffer, Len);
		return result;
	}
	int ReadDevice(OpcMP_plugin_t * plugin)
	{
	bool result = true;
	unsigned char WorkBufRecv[2048];	
	unsigned char WorkBufSend[2048];	
	if(plugin  == NULL)
			return -1;
	int count = RecvData(plugin,WorkBufRecv,sizeof(WorkBufRecv));
	if (count > 0)
	{

		SendData(plugin, WorkBufRecv,count);
		SetData(plugin, (char *)WorkBufRecv, count);
		return 1;
	}
	else
		return -1;
	}
